do not make PTY slave the controlling terminal
[ntk/apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
5d76cee1 3EXIT_CODE=0
8c1dd12c 4
8d876415 5# we all like colorful messages
1290422a 6if [ "$MSGCOLOR" != 'NO' ]; then
27cb4f6c 7 if [ ! -t 1 ]; then # but check that we output to a terminal
1290422a
DK
8 export MSGCOLOR='NO'
9 fi
10fi
11
12
13if [ "$MSGCOLOR" != 'NO' ]; then
14 CERROR="\033[1;31m" # red
15 CWARNING="\033[1;33m" # yellow
16 CMSG="\033[1;32m" # green
17 CINFO="\033[1;96m" # light blue
18 CDEBUG="\033[1;94m" # blue
19 CNORMAL="\033[0;39m" # default system console color
20 CDONE="\033[1;32m" # green
21 CPASS="\033[1;32m" # green
22 CFAIL="\033[1;31m" # red
23 CCMD="\033[1;35m" # pink
682a3bf7 24fi
8d876415 25
3c528b91
MO
26msgdie() { printf "${CERROR}E: $1${CNORMAL}\n" >&2; exit 1; }
27msgwarn() { printf "${CWARNING}W: $1${CNORMAL}\n" >&2; }
28msgmsg() { printf "${CMSG}$1${CNORMAL}\n"; }
29msginfo() { printf "${CINFO}I: $1${CNORMAL}\n"; }
30msgdebug() { printf "${CDEBUG}D: $1${CNORMAL}\n"; }
31msgdone() { printf "${CDONE}DONE${CNORMAL}\n"; }
32msgnwarn() { printf "${CWARNING}W: $1${CNORMAL}" >&2; }
33msgnmsg() { printf "${CMSG}$1${CNORMAL}"; }
34msgninfo() { printf "${CINFO}I: $1${CNORMAL}"; }
35msgndebug() { printf "${CDEBUG}D: $1${CNORMAL}"; }
2a2a7ef4
DK
36msgtest() {
37 while [ -n "$1" ]; do
3c528b91
MO
38 printf "${CINFO}$1${CCMD} "
39 printf -- "$(echo "$2" | sed -e 's#^apt\([cgfs]\)#apt-\1#')${CINFO} "
d73840dc
DK
40 shift
41 if [ -n "$1" ]; then shift; else break; fi
2a2a7ef4 42 done
3c528b91 43 printf "…${CNORMAL} "
2a2a7ef4 44}
3c528b91
MO
45msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
46msgskip() { printf "${CWARNING}SKIP${CNORMAL}\n" >&2; }
5229b285 47msgfail() {
3c528b91
MO
48 if [ $# -gt 0 ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
49 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
5229b285
DK
50 EXIT_CODE=$((EXIT_CODE+1));
51}
8d876415
DK
52
53# enable / disable Debugging
fc89263e
DK
54MSGLEVEL=${MSGLEVEL:-3}
55if [ $MSGLEVEL -le 0 ]; then
56 msgdie() { true; }
57fi
58if [ $MSGLEVEL -le 1 ]; then
59 msgwarn() { true; }
60 msgnwarn() { true; }
61fi
62if [ $MSGLEVEL -le 2 ]; then
63 msgmsg() { true; }
64 msgnmsg() { true; }
39cc8228 65 msgtest() { true; }
3c528b91
MO
66 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
67 msgskip() { printf " ${CWARNING}S${CNORMAL}" >&2; }
682a3bf7 68 if [ -n "$CFAIL" ]; then
3c528b91 69 msgfail() { printf " ${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE=$((EXIT_CODE+1)); }
682a3bf7 70 else
3c528b91 71 msgfail() { printf " ###FAILED###" >&2; EXIT_CODE=$((EXIT_CODE+1)); }
682a3bf7 72 fi
fc89263e
DK
73fi
74if [ $MSGLEVEL -le 3 ]; then
75 msginfo() { true; }
76 msgninfo() { true; }
77fi
78if [ $MSGLEVEL -le 4 ]; then
79 msgdebug() { true; }
80 msgndebug() { true; }
81fi
82msgdone() {
83 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
84 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
85 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
86 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
87 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
88 true;
89 else
3c528b91 90 printf "${CDONE}DONE${CNORMAL}\n";
fc89263e
DK
91 fi
92}
e43a426e
MV
93getaptconfig() {
94 if [ -f ./aptconfig.conf ]; then
95 echo "./aptconfig.conf"
96 elif [ -f ../aptconfig.conf ]; then
97 echo "../aptconfig.conf"
98 fi
99}
8d876415
DK
100runapt() {
101 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
846856f4
DK
102 local CMD="$1"
103 shift
3b8eb3bc 104 case $CMD in
e18f6133 105 sh|aptitude|*/*|command) ;;
3b8eb3bc
DK
106 *) CMD="${BUILDDIRECTORY}/$CMD";;
107 esac
83b880c6 108 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${BUILDDIRECTORY} $CMD "$@"
8d876415 109}
846856f4
DK
110aptconfig() { runapt apt-config "$@"; }
111aptcache() { runapt apt-cache "$@"; }
112aptcdrom() { runapt apt-cdrom "$@"; }
113aptget() { runapt apt-get "$@"; }
114aptftparchive() { runapt apt-ftparchive "$@"; }
115aptkey() { runapt apt-key "$@"; }
116aptmark() { runapt apt-mark "$@"; }
e1a69e71 117aptsortpkgs() { runapt apt-sortpkgs "$@"; }
796673c3 118apt() { runapt apt "$@"; }
3b8eb3bc
DK
119apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
120aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
121aptitude() { runapt aptitude "$@"; }
8d50b63f 122aptextracttemplates() { runapt apt-extracttemplates "$@"; }
3082603f 123aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
3b8eb3bc 124
158fda31 125dpkg() {
846856f4 126 command dpkg --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log "$@"
158fda31 127}
ce7f128c
DK
128dpkgcheckbuilddeps() {
129 command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@"
b6b5a542 130}
3fa950f1
DK
131gdb() {
132 echo "gdb: run »$*«"
ce928105
MV
133 CMD="$1"
134 shift
135
136 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${LIBRARYPATH} command gdb ${BUILDDIRECTORY}/$CMD --args ${BUILDDIRECTORY}/$CMD "$@"
ae99ce2e 137}
77a45beb
DK
138gpg() {
139 # see apt-key for the whole trickery. Setup is done in setupenvironment
140 command gpg --ignore-time-conflict --no-options --no-default-keyring \
141 --homedir "${TMPWORKINGDIRECTORY}/gnupghome" \
142 --no-auto-check-trustdb --trust-model always \
143 "$@"
144}
8d876415 145
8c1dd12c 146exitwithstatus() {
f91bd741
MV
147 # error if we about to overflow, but ...
148 # "255 failures ought to be enough for everybody"
5d76cee1
MV
149 if [ $EXIT_CODE -gt 255 ]; then
150 msgdie "Total failure count $EXIT_CODE too big"
f91bd741 151 fi
5d76cee1 152 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
8c1dd12c
MV
153}
154
804d4a0d
DK
155shellsetedetector() {
156 local exit_status=$?
157 if [ "$exit_status" != '0' ]; then
3c528b91 158 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
804d4a0d
DK
159 if [ "$EXIT_CODE" = '0' ]; then
160 EXIT_CODE="$exit_status"
161 fi
162 fi
163}
164
b720d0bd 165addtrap() {
8437b7d4
DK
166 if [ "$1" = 'prefix' ]; then
167 CURRENTTRAP="$2 $CURRENTTRAP"
168 else
169 CURRENTTRAP="$CURRENTTRAP $1"
170 fi
804d4a0d 171 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
b720d0bd 172}
8d876415
DK
173
174setupenvironment() {
75954ae2 175 TMPWORKINGDIRECTORY=$(mktemp -d)
53ea1b56 176 TESTDIRECTORY=$(readlink -f $(dirname $0))
3cbbda3c 177 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
5c0dd6fc
MV
178
179 # allow overriding the default BUILDDIR location
180 BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
3b8eb3bc 181 LIBRARYPATH=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
5c0dd6fc 182 METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
e43a426e 183 APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
c035b655 184 APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
3082603f 185 APTINTERNALSOLVER=${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}
8d876415 186 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
5c0dd6fc
MV
187 # -----
188
8437b7d4 189 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
8d876415 190 cd $TMPWORKINGDIRECTORY
cd725954 191 mkdir rootdir aptarchive keys
8d876415 192 cd rootdir
b29c3712 193 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
33677a0c 194 mkdir -p var/cache var/lib/apt var/log tmp
cffea9af 195 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
cd725954 196 touch var/lib/dpkg/available
8d876415 197 mkdir -p usr/lib/apt
9082a1fc 198 ln -s ${METHODSDIR} usr/lib/apt/methods
1f6cf9e7
DK
199 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
200 mkdir -p usr/lib/apt/solvers
201 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
202 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
203 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
204 fi
291a386f
MV
205 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
206 # system
207 if [ -e ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove ]; then
208 ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove
209 else
210 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
211 fi
8d876415 212 cd ..
2c6baa5a 213 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
53ea1b56
DK
214 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
215 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 216 fi
4a4ea26c 217 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
53ea1b56
DK
218 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
219 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 220 fi
53ea1b56 221 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
cd725954 222 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 223 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 224 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
225 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
226 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
5c0dd6fc 227 echo "Dir::Bin::Methods \"${METHODSDIR}\";" >> aptconfig.conf
cffea9af
DK
228 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
229 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
230 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
231 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
232 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
846856f4 233 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
53ea1b56
DK
234 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
235 fi
cffea9af 236 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 237 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
23af9f40 238 echo "Acquire::https::CaInfo \"${TESTDIR}/apt.pem\";" > rootdir/etc/apt/apt.conf.d/99https
14109555 239 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
276e51dd 240 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
77a45beb
DK
241
242 # gpg needs a trustdb to function, but it can't be invalid (not even empty)
243 # see also apt-key where this trickery comes from:
244 local TRUSTDBDIR="${TMPWORKINGDIRECTORY}/gnupghome"
245 mkdir "$TRUSTDBDIR"
246 chmod 700 "$TRUSTDBDIR"
247 # We also don't use a secret keyring, of course, but gpg panics and
248 # implodes if there isn't one available - and writeable for imports
249 local SECRETKEYRING="${TRUSTDBDIR}/secring.gpg"
250 touch $SECRETKEYRING
251 # now create the trustdb with an (empty) dummy keyring
252 # newer gpg versions are fine without it, but play it safe for now
253 gpg --quiet --check-trustdb --secret-keyring $SECRETKEYRING --keyring $SECRETKEYRING >/dev/null 2>&1
254
ce7f128c 255 # cleanup the environment a bit
be233796
DK
256 export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
257 export LC_ALL=C.UTF-8
3b8eb3bc 258 unset LANGUAGE APT_CONFIG
ce7f128c
DK
259 unset GREP_OPTIONS DEB_BUILD_PROFILES
260
8d876415
DK
261 msgdone "info"
262}
263
ea65d079
DK
264getarchitecture() {
265 if [ "$1" = "native" -o -z "$1" ]; then
266 eval `aptconfig shell ARCH APT::Architecture`
267 if [ -n "$ARCH" ]; then
268 echo $ARCH
269 else
5834d7a1 270 dpkg --print-architecture
ea65d079
DK
271 fi
272 else
273 echo $1
274 fi
275}
276
53ea1b56
DK
277getarchitectures() {
278 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
279}
280
3dcdc1f9
DK
281getarchitecturesfromcommalist() {
282 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
283}
284
8d876415 285configarchitecture() {
18908589
DK
286 {
287 echo "APT::Architecture \"$(getarchitecture $1)\";"
288 while [ -n "$1" ]; do
289 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
290 shift
291 done
292 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
53ea1b56
DK
293 configdpkg
294}
295
296configdpkg() {
297 if [ ! -e rootdir/var/lib/dpkg/status ]; then
298 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
299 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
300 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
301 else
302 echo -n > rootdir/var/lib/dpkg/status
303 fi
304 fi
18908589 305 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
846856f4 306 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
53ea1b56
DK
307 local ARCHS="$(getarchitectures)"
308 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
309 DPKGARCH="$(dpkg --print-architecture)"
310 for ARCH in ${ARCHS}; do
feae193b 311 if [ "${ARCH}" != "${DPKGARCH}" ]; then
18908589 312 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
feae193b 313 # old-style used e.g. in Ubuntu-P – and as it seems travis
18908589
DK
314 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
315 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
feae193b
DK
316 fi
317 fi
53ea1b56
DK
318 done
319 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
05343a22
DK
320 # dpkg doesn't really check the version as long as it is fully installed,
321 # but just to be sure we choose one above the required version
322 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
53ea1b56
DK
323 fi
324 fi
325 fi
8d876415
DK
326}
327
9fc0b435
DK
328configdpkgnoopchroot() {
329 # create a library to noop chroot() and rewrite maintainer script executions
330 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
331 # chroot directory dpkg could chroot into to execute the maintainer scripts
332 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
333 cat << EOF > noopchroot.c
334#define _GNU_SOURCE
335#include <stdio.h>
336#include <stdlib.h>
337#include <string.h>
338#include <dlfcn.h>
339
340static char * chrootdir = NULL;
341
342int chroot(const char *path) {
343 printf("WARNING: CHROOTing to %s was ignored!\n", path);
344 free(chrootdir);
345 chrootdir = strdup(path);
346 return 0;
347}
348int execvp(const char *file, char *const argv[]) {
349 static int (*func_execvp) (const char *, char * const []) = NULL;
350 if (func_execvp == NULL)
351 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
352 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
353 return func_execvp(file, argv);
354 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
355 char newfile[strlen(chrootdir) + strlen(file)];
356 strcpy(newfile, chrootdir);
357 strcat(newfile, file);
358 return func_execvp(newfile, argv);
359}
360EOF
361 testsuccess --nomsg gcc -fPIC -shared -o noopchroot.so noopchroot.c -ldl
362
363 mkdir -p "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
364 DPKG="${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg"
365 echo "#!/bin/sh
366if [ -n \"\$LD_PRELOAD\" ]; then
367 export LD_PRELOAD=\"${TMPWORKINGDIRECTORY}/noopchroot.so \${LD_PRELOAD}\"
368else
369 export LD_PRELOAD=\"${TMPWORKINGDIRECTORY}/noopchroot.so\"
370fi
371dpkg \"\$@\"" > $DPKG
372 chmod +x $DPKG
373 sed -ie "s|^DPKG::options:: \"dpkg\";\$|DPKG::options:: \"$DPKG\";|" aptconfig.conf
374}
375
376configallowinsecurerepositories() {
377 echo "Acquire::AllowInsecureRepositories \"$1\";" > rootdir/etc/apt/apt.conf.d/allow-insecure-repositories.conf
378
379}
380
276e51dd
DK
381configcompression() {
382 while [ -n "$1" ]; do
383 case "$1" in
3c528b91
MO
384 '.') printf ".\t.\tcat\n";;
385 'gz') printf "gzip\tgz\tgzip\n";;
386 'bz2') printf "bzip2\tbz2\tbzip2\n";;
387 'lzma') printf "lzma\tlzma\txz --format=lzma\n";;
388 'xz') printf "xz\txz\txz\n";;
389 *) printf "$1\t$1\t$1\n";;
276e51dd
DK
390 esac
391 shift
392 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
393}
394
5f982b9d
DK
395forcecompressor() {
396 COMPRESSOR="$1"
397 COMPRESSOR_CMD="$1"
398 case $COMPRESSOR in
399 gzip) COMPRESS='gz';;
400 bzip2) COMPRESS='bz2';;
401 lzma) COMPRESS='lzma';;
402 xz) COMPRESS='xz';;
403 *) msgdie "Compressor $COMPRESSOR is unknown to framework, so can't be forced by forcecompressor!";;
404 esac
405 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
406 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
407Dir::Bin::uncompressed \"/does/not/exist\";
408Dir::Bin::gzip \"/does/not/exist\";
409Dir::Bin::bzip2 \"/does/not/exist\";
410Dir::Bin::lzma \"/does/not/exist\";
411Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
412 if [ -e "/bin/${COMPRESSOR}" ]; then
413 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE"
414 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
415 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE"
416 elif [ "${COMPRESSOR}" = 'lzma' ]; then
417 echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE"
418 COMPRESSOR_CMD='xz --format=lzma'
419 else
420 msgtest 'Test for availability of compressor' "${COMPRESSOR}"
421 msgfail
422 fi
423}
424
75954ae2 425setupsimplenativepackage() {
ce9864a8
DK
426 local NAME="$1"
427 local ARCH="$2"
428 local VERSION="$3"
429 local RELEASE="${4:-unstable}"
430 local DEPENDENCIES="$5"
14109555 431 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
432 If you find such a package installed on your system,
433 something went horribly wrong! They are autogenerated
434 und used only by testcases and surf no other propose…"}"
435
b7899b00
DK
436 local SECTION="${7:-others}"
437 local DISTSECTION
438 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
439 DISTSECTION="main"
440 else
441 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
442 fi
ce9864a8
DK
443 local BUILDDIR=incoming/${NAME}-${VERSION}
444 mkdir -p ${BUILDDIR}/debian/source
445 cd ${BUILDDIR}
446 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
447 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
448 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
449
450 * Initial release
451
b7899b00
DK
452 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
453 test -e debian/control || echo "Source: $NAME
454Section: $SECTION
ce9864a8
DK
455Priority: optional
456Maintainer: Joe Sixpack <joe@example.org>
457Build-Depends: debhelper (>= 7)
458Standards-Version: 3.9.1
459
875bcb36
DK
460Package: $NAME" > debian/control
461 if [ "$ARCH" = 'all' ]; then
462 echo "Architecture: all" >> debian/control
463 else
464 echo "Architecture: any" >> debian/control
465 fi
ce9864a8 466 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
18908589
DK
467 echo "Description: $DESCRIPTION" >> debian/control
468
b7899b00
DK
469 test -e debian/compat || echo "7" > debian/compat
470 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 471 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
472 cd - > /dev/null
473}
474
475buildsimplenativepackage() {
476 local NAME="$1"
477 local ARCH="$2"
478 local VERSION="$3"
479 local RELEASE="${4:-unstable}"
480 local DEPENDENCIES="$5"
14109555 481 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
482 If you find such a package installed on your system,
483 something went horribly wrong! They are autogenerated
484 und used only by testcases and surf no other propose…"}"
485
75954ae2 486 local SECTION="${7:-others}"
d67004e0 487 local PRIORITY="${8:-optional}"
42c1513b 488 local FILE_TREE="$9"
adff049d 489 local COMPRESS_TYPE="${10:-gzip}"
75954ae2
DK
490 local DISTSECTION
491 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
492 DISTSECTION="main"
493 else
494 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
495 fi
5a635ee4 496 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 497
9fc0b435 498 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
b761356f
DK
499 mkdir -p $BUILDDIR/debian/source
500 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
501 echo "#!/bin/sh
502echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
503
504 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
505 echo "$NAME ($VERSION) $RELEASE; urgency=low
506
507 * Initial release
508
509 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
510 echo "Source: $NAME
511Section: $SECTION
d67004e0 512Priority: $PRIORITY
b761356f 513Maintainer: Joe Sixpack <joe@example.org>
01f520ce
DK
514Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
515 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
516 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
517 echo "
518Package: $NAME" >> ${BUILDDIR}/debian/control
b761356f 519
875bcb36
DK
520 if [ "$ARCH" = 'all' ]; then
521 echo "Architecture: all" >> ${BUILDDIR}/debian/control
522 else
523 echo "Architecture: any" >> ${BUILDDIR}/debian/control
524 fi
01f520ce
DK
525 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
526 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
18908589 527 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
01f520ce 528
b761356f 529 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
9fc0b435
DK
530 cd ${BUILDDIR}/..
531 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
532 cd - >/dev/null
533 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output \
f1828b69 534 | while read SRC; do
5a635ee4 535 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
f1828b69 536# if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
77a45beb 537# gpg --yes --secret-keyring ./keys/joesixpack.sec \
f1828b69
DK
538# --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \
539# --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
540# mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
541# fi
b761356f 542 done
84aa13f4 543
3dcdc1f9 544 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
9fc0b435 545 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
84aa13f4
DK
546 rm -rf ${BUILDDIR}/debian/tmp
547 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
548 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
549 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
42c1513b
MV
550 if [ -n "$FILE_TREE" ]; then
551 cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp
552 fi
42c1513b 553
84aa13f4
DK
554 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
555 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
846856f4 556 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
eb9dee96
DK
557 # ensure the right permissions as dpkg-deb ensists
558 chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN
9fc0b435 559 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/..
84aa13f4
DK
560 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
561 done
562
13845042
DK
563 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
564 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
565 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
5a635ee4 566 rm -rf "${BUILDDIR}"
b761356f 567 msgdone "info"
75954ae2
DK
568}
569
570buildpackage() {
571 local BUILDDIR=$1
572 local RELEASE=$2
573 local SECTION=$3
ea65d079 574 local ARCH=$(getarchitecture $4)
846856f4
DK
575 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
576 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
9fc0b435 577 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
75954ae2
DK
578 cd $BUILDDIR
579 if [ "$ARCH" = "all" ]; then
580 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
581 fi
9fc0b435
DK
582 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
583 cp ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output $BUILDLOG
846856f4
DK
584 local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
585 local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 586 cd - > /dev/null
b7899b00 587 for PKG in $PKGS; do
75954ae2 588 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
589 done
590 for SRC in $SRCS; do
75954ae2 591 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 592 done
ce9864a8
DK
593}
594
595buildaptarchive() {
ce9864a8 596 if [ -d incoming ]; then
846856f4 597 buildaptarchivefromincoming "$@"
ce9864a8 598 else
846856f4 599 buildaptarchivefromfiles "$@"
ce9864a8
DK
600 fi
601}
602
603createaptftparchiveconfig() {
276e51dd
DK
604 local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
605 COMPRESSORS="${COMPRESSORS%* }"
ce9864a8 606 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
607 if [ -z "$ARCHS" ]; then
608 # the pool is empty, so we will operate on faked packages - let us use the configured archs
53ea1b56 609 ARCHS="$(getarchitectures)"
158fda31 610 fi
ce9864a8
DK
611 echo -n 'Dir {
612 ArchiveDir "' >> ftparchive.conf
613 echo -n $(readlink -f .) >> ftparchive.conf
614 echo -n '";
615 CacheDir "' >> ftparchive.conf
616 echo -n $(readlink -f ..) >> ftparchive.conf
617 echo -n '";
b7899b00
DK
618 FileListDir "' >> ftparchive.conf
619 echo -n $(readlink -f pool/) >> ftparchive.conf
620 echo -n '";
621};
622Default {
276e51dd
DK
623 Packages::Compress "'"$COMPRESSORS"'";
624 Sources::Compress "'"$COMPRESSORS"'";
625 Contents::Compress "'"$COMPRESSORS"'";
626 Translation::Compress "'"$COMPRESSORS"'";
18331adf 627 LongDescription "false";
ce9864a8
DK
628};
629TreeDefault {
630 Directory "pool/";
631 SrcDirectory "pool/";
632};
633APT {
634 FTPArchive {
635 Release {
636 Origin "joesixpack";
637 Label "apttestcases";
638 Suite "unstable";
639 Description "repository with dummy packages";
640 Architectures "' >> ftparchive.conf
641 echo -n "$ARCHS" >> ftparchive.conf
642 echo 'source";
643 };
644 };
645};' >> ftparchive.conf
b7899b00
DK
646 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
647 echo -n 'tree "dists/' >> ftparchive.conf
648 echo -n "$DIST" >> ftparchive.conf
649 echo -n '" {
ce9864a8
DK
650 Architectures "' >> ftparchive.conf
651 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
652 echo -n 'source";
653 FileList "' >> ftparchive.conf
654 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
655 echo -n '";
656 SourceFileList "' >> ftparchive.conf
657 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
658 echo -n '";
659 Sections "' >> ftparchive.conf
660 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
661 echo '";
ce9864a8 662};' >> ftparchive.conf
b7899b00 663 done
ce9864a8
DK
664}
665
666buildaptftparchivedirectorystructure() {
b7899b00
DK
667 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
668 for DIST in $DISTS; do
669 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
670 for SECTION in $SECTIONS; do
671 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
672 for ARCH in $ARCHS; do
673 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
674 done
675 mkdir -p dists/${DIST}/${SECTION}/source
676 mkdir -p dists/${DIST}/${SECTION}/i18n
677 done
ce9864a8 678 done
ce9864a8
DK
679}
680
9b78cda6
DK
681insertpackage() {
682 local RELEASE="$1"
683 local NAME="$2"
684 local ARCH="$3"
685 local VERSION="$4"
686 local DEPENDENCIES="$5"
d67004e0 687 local PRIORITY="${6:-optional}"
14109555 688 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
689 If you find such a package installed on your system,
690 something went horribly wrong! They are autogenerated
691 und used only by testcases and surf no other propose…"}"
d67004e0 692 local ARCHS=""
3dcdc1f9 693 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
c919ad6e 694 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
53ea1b56 695 ARCHS="$(getarchitectures)"
d67004e0
DK
696 else
697 ARCHS="$arch"
698 fi
699 for BUILDARCH in $ARCHS; do
700 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
701 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
702 touch aptarchive/dists/${RELEASE}/main/source/Sources
703 local FILE="${PPATH}/Packages"
704 echo "Package: $NAME
705Priority: $PRIORITY
9b78cda6 706Section: other
2c085486 707Installed-Size: 42
c919ad6e
DK
708Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
709 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
710 echo "Version: $VERSION
d67004e0
DK
711Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
712 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
18908589 713 echo "Description: $DESCRIPTION" >> $FILE
8ba17539 714 echo >> $FILE
d67004e0 715 done
9b78cda6
DK
716 done
717}
718
234675b7
DK
719insertsource() {
720 local RELEASE="$1"
721 local NAME="$2"
722 local ARCH="$3"
723 local VERSION="$4"
724 local DEPENDENCIES="$5"
725 local ARCHS=""
726 local SPATH="aptarchive/dists/${RELEASE}/main/source"
727 mkdir -p $SPATH
728 local FILE="${SPATH}/Sources"
729 echo "Package: $NAME
730Binary: $NAME
731Version: $VERSION
732Maintainer: Joe Sixpack <joe@example.org>
733Architecture: $ARCH" >> $FILE
734 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
735 echo "Files:
736 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
d5dea0be
DK
737 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
738" >> $FILE
234675b7
DK
739}
740
dfc2b1be
DK
741insertinstalledpackage() {
742 local NAME="$1"
743 local ARCH="$2"
744 local VERSION="$3"
745 local DEPENDENCIES="$4"
d67004e0 746 local PRIORITY="${5:-optional}"
d4b4e5ea 747 local STATUS="${6:-install ok installed}"
14109555 748 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
18908589
DK
749 If you find such a package installed on your system,
750 something went horribly wrong! They are autogenerated
751 und used only by testcases and surf no other propose…"}"
752
53ea1b56
DK
753 local FILE='rootdir/var/lib/dpkg/status'
754 local INFO='rootdir/var/lib/dpkg/info'
3dcdc1f9 755 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
d67004e0 756 echo "Package: $NAME
d4b4e5ea 757Status: $STATUS
d67004e0 758Priority: $PRIORITY
dfc2b1be
DK
759Section: other
760Installed-Size: 42
761Maintainer: Joe Sixpack <joe@example.org>
dfc2b1be 762Version: $VERSION" >> $FILE
c919ad6e 763 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
d67004e0 764 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
18908589
DK
765 echo "Description: $DESCRIPTION" >> $FILE
766 echo >> $FILE
53ea1b56
DK
767 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
768 echo -n > ${INFO}/${NAME}:${arch}.list
769 else
770 echo -n > ${INFO}/${NAME}.list
771 fi
d67004e0 772 done
dfc2b1be
DK
773}
774
775
ce9864a8 776buildaptarchivefromincoming() {
3cbbda3c 777 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
778 cd aptarchive
779 [ -e pool ] || ln -s ../incoming pool
780 [ -e ftparchive.conf ] || createaptftparchiveconfig
781 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 782 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 783 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
784 cd - > /dev/null
785 msgdone "info"
9b78cda6 786 generatereleasefiles
ce9864a8
DK
787}
788
789buildaptarchivefromfiles() {
3cbbda3c 790 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
791 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
792 msgninfo "\t${line} file… "
276e51dd 793 compressfile "$line" "$1"
8d876415 794 msgdone "info"
9b78cda6 795 done
e3c62328 796 generatereleasefiles "$@"
9b78cda6
DK
797}
798
276e51dd
DK
799compressfile() {
800 cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do
801 if [ "$compressor" = '.' ]; then
802 if [ -n "$2" ]; then
803 touch -d "$2" "$1"
804 fi
805 continue
806 fi
807 cat "$1" | $command > "${1}.${extension}"
808 if [ -n "$2" ]; then
809 touch -d "$2" "${1}.${extension}"
810 fi
811 done
812}
813
a3bbbab7 814# can be overridden by testcases for their pleasure
bf9e7447
DK
815getcodenamefromsuite() {
816 case "$1" in
817 unstable) echo 'sid';;
818 *) echo -n "$1";;
819 esac
820}
a3bbbab7 821getreleaseversionfromsuite() { true; }
718f797c 822getlabelfromsuite() { true; }
a3bbbab7 823
9b78cda6 824generatereleasefiles() {
884a4c0a
DK
825 # $1 is the Date header and $2 is the ValidUntil header to be set
826 # both should be given in notation date/touch can understand
9b78cda6
DK
827 msgninfo "\tGenerate Release files… "
828 if [ -e aptarchive/dists ]; then
829 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
a3bbbab7
DK
830 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
831 local CODENAME="$(getcodenamefromsuite $SUITE)"
832 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 833 local LABEL="$(getlabelfromsuite $SUITE)"
884a4c0a 834 if [ -n "$VERSION" ]; then
718f797c
DK
835 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
836 fi
837 if [ -n "$LABEL" ]; then
838 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
a3bbbab7 839 fi
884a4c0a
DK
840 aptftparchive -qq release $dir \
841 -o APT::FTPArchive::Release::Suite="${SUITE}" \
842 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
718f797c 843 ${LABEL} \
884a4c0a
DK
844 ${VERSION} \
845 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
a3bbbab7 846 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11
DK
847 sed -i '/^Date: / a\
848NotAutomatic: yes' $dir/Release
849 fi
884a4c0a
DK
850 if [ -n "$1" -a "$1" != "now" ]; then
851 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
852 fi
853 if [ -n "$2" ]; then
854 sed -i "/^Date: / a\
855Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
856 fi
9b78cda6
DK
857 done
858 else
859 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 860 fi
884a4c0a 861 if [ -n "$1" -a "$1" != "now" ]; then
fe0f7911
DK
862 for release in $(find ./aptarchive -name 'Release'); do
863 touch -d "$1" $release
864 done
8d876415 865 fi
b7899b00 866 msgdone "info"
8d876415
DK
867}
868
b7899b00
DK
869setupdistsaptarchive() {
870 local APTARCHIVE=$(readlink -f ./aptarchive)
871 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
872 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
873 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
874 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
875 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
876 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
877 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
878 msgdone "info"
879 done
880}
881
882setupflataptarchive() {
ce9864a8 883 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
884 if [ -f ${APTARCHIVE}/Packages ]; then
885 msgninfo "\tadd deb sources.list line… "
886 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
887 msgdone "info"
888 else
889 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
890 fi
891 if [ -f ${APTARCHIVE}/Sources ]; then
892 msgninfo "\tadd deb-src sources.list line… "
893 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
894 msgdone "info"
895 else
896 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
897 fi
b7899b00
DK
898}
899
900setupaptarchive() {
901 buildaptarchive
902 if [ -e aptarchive/dists ]; then
903 setupdistsaptarchive
904 else
905 setupflataptarchive
906 fi
f213b6ea 907 signreleasefiles
b2ea1a47
DK
908 if [ "$1" != '--no-update' ]; then
909 msgninfo "\tSync APT's cache with the archive… "
910 aptget update -qq
911 msgdone "info"
912 fi
8d876415
DK
913}
914
f213b6ea
DK
915signreleasefiles() {
916 local SIGNER="${1:-Joe Sixpack}"
77a45beb 917 local GPG="gpg --batch --yes"
f213b6ea 918 msgninfo "\tSign archive with $SIGNER key… "
29a59c46
DK
919 local REXKEY='keys/rexexpired'
920 local SECEXPIREBAK="${REXKEY}.sec.bak"
921 local PUBEXPIREBAK="${REXKEY}.pub.bak"
922 if [ "${SIGNER}" = 'Rex Expired' ]; then
923 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
924 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
925 # therefore we 'temporary' make the key not expired and restore a backup after signing
926 cp ${REXKEY}.sec $SECEXPIREBAK
927 cp ${REXKEY}.pub $PUBEXPIREBAK
928 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
929 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
930 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
931 cp $SECUNEXPIRED ${REXKEY}.sec
932 cp $PUBUNEXPIRED ${REXKEY}.pub
933 else
934 printf "expire\n1w\nsave\n" | $GPG --keyring ${REXKEY}.pub --secret-keyring ${REXKEY}.sec --command-fd 0 --edit-key "${SIGNER}" >/dev/null 2>&1 || true
935 cp ${REXKEY}.sec $SECUNEXPIRED
936 cp ${REXKEY}.pub $PUBUNEXPIRED
937 fi
938 fi
f213b6ea 939 for KEY in $(find keys/ -name '*.sec'); do
29a59c46 940 GPG="$GPG --secret-keyring $KEY"
f213b6ea 941 done
f213b6ea 942 for KEY in $(find keys/ -name '*.pub'); do
29a59c46 943 GPG="$GPG --keyring $KEY"
f213b6ea
DK
944 done
945 for RELEASE in $(find aptarchive/ -name Release); do
29a59c46 946 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE}
e3c62328 947 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
29a59c46 948 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
e3c62328
DK
949 # we might have set a specific date for the Release file, so copy it
950 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE}
f213b6ea 951 done
29a59c46
DK
952 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
953 mv -f $SECEXPIREBAK ${REXKEY}.sec
954 mv -f $PUBEXPIREBAK ${REXKEY}.pub
955 fi
f213b6ea
DK
956 msgdone "info"
957}
958
f2c0ec8b
DK
959webserverconfig() {
960 msgtest "Set webserver config option '${1}' to" "$2"
0d58c26a
DK
961 local DOWNLOG='rootdir/tmp/download-testfile.log'
962 local STATUS='rootdir/tmp/webserverconfig.status'
963 rm -f "$STATUS" "$DOWNLOG"
964 if downloadfile "http://localhost:8080/_config/set/${1}/${2}" "$STATUS" > "$DOWNLOG"; then
f2c0ec8b
DK
965 msgpass
966 else
0d58c26a
DK
967 cat "$DOWNLOG" "$STATUS"
968 msgfail
f2c0ec8b 969 fi
0d58c26a 970 testwebserverlaststatuscode '200'
f2c0ec8b
DK
971}
972
fd46d305
DK
973rewritesourceslist() {
974 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
975 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
976 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#http://localhost:4433/#${1}#"
977 done
978}
979
5572f6bd
MV
980# wait for up to 10s for a pid file to appear to avoid possible race
981# when a helper is started and dosn't write the PID quick enough
982waitforpidfile() {
983 local PIDFILE="$1"
984 for i in $(seq 10); do
985 if test -s "$PIDFILE"; then
986 return 0
987 fi
988 sleep 1
989 done
990 msgdie "waiting for $PIDFILE failed"
991 return 1
992}
993
f213b6ea 994changetowebserver() {
23af9f40
DK
995 if [ "$1" != '--no-rewrite' ]; then
996 rewritesourceslist 'http://localhost:8080/'
997 else
998 shift
999 fi
5c0dd6fc 1000 if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then
fbd29dd6 1001 cd aptarchive
a0db467c
DK
1002 local LOG="webserver.log"
1003 if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then
bee0670b
DK
1004 cat $LOG
1005 false
1006 fi
5572f6bd 1007 waitforpidfile aptwebserver.pid
e3c62328
DK
1008 local PID="$(cat aptwebserver.pid)"
1009 if [ -z "$PID" ]; then
1010 msgdie 'Could not fork aptwebserver successfully'
1011 fi
1012 addtrap "kill $PID;"
fbd29dd6 1013 cd - > /dev/null
c5bcc607 1014 else
fbd29dd6 1015 msgdie 'You have to build aptwerbserver or install a webserver'
f213b6ea 1016 fi
fd46d305
DK
1017}
1018
1019changetohttpswebserver() {
1020 if ! which stunnel4 >/dev/null; then
1021 msgdie 'You need to install stunnel4 for https testcases'
1022 fi
1023 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
dc95fee1 1024 changetowebserver --no-rewrite "$@"
fd46d305
DK
1025 fi
1026 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
1027cert = ${TESTDIRECTORY}/apt.pem
23af9f40 1028output = /dev/null
fd46d305
DK
1029
1030[https]
1031accept = 4433
1032connect = 8080
1033" > ${TMPWORKINGDIRECTORY}/stunnel.conf
1034 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
5572f6bd 1035 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
fd46d305 1036 local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
5572f6bd
MV
1037 if [ -z "$PID" ]; then
1038 msgdie 'Could not fork stunnel4 successfully'
1039 fi
fd46d305
DK
1040 addtrap 'prefix' "kill ${PID};"
1041 rewritesourceslist 'https://localhost:4433/'
f213b6ea
DK
1042}
1043
c45233ea
DK
1044changetocdrom() {
1045 mkdir -p rootdir/media/cdrom/.disk
1046 local CD="$(readlink -f rootdir/media/cdrom)"
a0975c8d
DK
1047 echo "acquire::cdrom::mount \"${CD}\";
1048acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
1049acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
1050acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom
c45233ea
DK
1051 echo -n "$1" > ${CD}/.disk/info
1052 if [ ! -d aptarchive/dists ]; then
1053 msgdie 'Flat file archive cdroms can not be created currently'
1054 return 1
1055 fi
a0975c8d 1056 mv aptarchive/dists "$CD"
c45233ea
DK
1057 ln -s "$(readlink -f ./incoming)" $CD/pool
1058 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
a0975c8d
DK
1059 # start with an unmounted disk
1060 mv "${CD}" "${CD}-unmounted"
1061 # we don't want the disk to be modifiable
1062 addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
1063 chmod -R -w rootdir/media/cdrom-unmounted/dists
c45233ea
DK
1064}
1065
fd46d305 1066downloadfile() {
92e8c1ff
DK
1067 local PROTO="${1%%:*}"
1068 apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
0d58c26a 1069 download-file "$1" "$2" 2>&1 || true
fd46d305
DK
1070 # only if the file exists the download was successful
1071 if [ -e "$2" ]; then
1072 return 0
1073 else
1074 return 1
1075 fi
1076}
1077
f213b6ea 1078checkdiff() {
846856f4 1079 local DIFFTEXT="$(command diff -u "$@" | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
8d876415 1080 if [ -n "$DIFFTEXT" ]; then
0d58c26a
DK
1081 echo >&2
1082 echo >&2 "$DIFFTEXT"
8d876415
DK
1083 return 1
1084 else
1085 return 0
1086 fi
1087}
1088
75954ae2
DK
1089testfileequal() {
1090 local FILE="$1"
1091 shift
1092 msgtest "Test for correctness of file" "$FILE"
1093 if [ -z "$*" ]; then
f213b6ea 1094 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 1095 else
f213b6ea 1096 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
1097 fi
1098}
1099
b855a400
DK
1100testempty() {
1101 msgtest "Test for no output of" "$*"
859093da
DK
1102 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1103 if $* >$COMPAREFILE 2>&1 && test ! -s $COMPAREFILE; then
1104 msgpass
1105 else
1106 cat $COMPAREFILE
1107 msgfail
1108 fi
b855a400
DK
1109}
1110
f74a6fa1
DK
1111testequal() {
1112 local MSG='Test of equality of'
1113 if [ "$1" = '--nomsg' ]; then
1114 MSG=''
1115 shift
1116 fi
1117
03938280 1118 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
8d876415
DK
1119 echo "$1" > $COMPAREFILE
1120 shift
d2d68aaf 1121
f74a6fa1
DK
1122 if [ -n "$MSG" ]; then
1123 msgtest "$MSG" "$*"
1124 fi
9fc0b435 1125 "$@" 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
1126}
1127
685625bd 1128testequalor2() {
03938280
DK
1129 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1130 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1131 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
685625bd
DK
1132 echo "$1" > $COMPAREFILE1
1133 echo "$2" > $COMPAREFILE2
1134 shift 2
1135 msgtest "Test for equality OR of" "$*"
18908589 1136 $* >$COMPAREAGAINST 2>&1 || true
0d58c26a
DK
1137 if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \
1138 checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1
1139 then
0caa5a4c
DK
1140 msgpass
1141 else
1142 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}"
1143 checkdiff $COMPAREFILE1 $COMPAREAGAINST || true
1144 echo -n "${CINFO}Diff against OR 2${CNORMAL}"
1145 checkdiff $COMPAREFILE2 $COMPAREAGAINST || true
1146 msgfail
1147 fi
685625bd
DK
1148}
1149
8d876415 1150testshowvirtual() {
edc0ef10 1151 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1152 local PACKAGE="$1"
1153 shift
1154 while [ -n "$1" ]; do
1155 VIRTUAL="${VIRTUAL}
edc0ef10 1156N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1157 PACKAGE="${PACKAGE} $1"
1158 shift
1159 done
1160 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1161 VIRTUAL="${VIRTUAL}
4bec02c2 1162N: No packages found"
03938280 1163 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
ea65d079 1164 local ARCH="$(getarchitecture 'native')"
8d876415 1165 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 1166 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
1167}
1168
1169testnopackage() {
1170 msgtest "Test for non-existent packages" "apt-cache show $*"
846856f4 1171 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
8d876415 1172 if [ -n "$SHOWPKG" ]; then
0d58c26a
DK
1173 echo >&2
1174 echo >&2 "$SHOWPKG"
8d876415 1175 msgfail
0d58c26a
DK
1176 else
1177 msgpass
8d876415 1178 fi
8d876415 1179}
01a6e24c
DK
1180
1181testdpkginstalled() {
1182 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
846856f4 1183 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep '^i' | wc -l)"
87bc1c45 1184 if [ "$PKGS" != $# ]; then
0d58c26a
DK
1185 echo >&2 $PKGS
1186 dpkg -l "$@" | grep '^[a-z]' >&2
01a6e24c 1187 msgfail
0d58c26a
DK
1188 else
1189 msgpass
01a6e24c 1190 fi
01a6e24c
DK
1191}
1192
5cf733e1
DK
1193testdpkgnotinstalled() {
1194 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
846856f4 1195 local PKGS="$(dpkg -l "$@" 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
1196 if [ "$PKGS" != 0 ]; then
1197 echo
0d58c26a 1198 dpkg -l "$@" | grep '^[a-z]' >&2
01a6e24c 1199 msgfail
0d58c26a
DK
1200 else
1201 msgpass
01a6e24c 1202 fi
01a6e24c 1203}
ec7f904e
DK
1204
1205testmarkedauto() {
03938280 1206 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
ec7f904e
DK
1207 if [ -n "$1" ]; then
1208 msgtest 'Test for correctly marked as auto-installed' "$*"
1209 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1210 else
1211 msgtest 'Test for correctly marked as auto-installed' 'no package'
c98fb5e0 1212 echo -n > $COMPAREFILE
ec7f904e
DK
1213 fi
1214 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1215}
89a1aa5d 1216
0440d936
DK
1217testsuccess() {
1218 if [ "$1" = '--nomsg' ]; then
1219 shift
1220 else
1221 msgtest 'Test for successful execution of' "$*"
1222 fi
03938280 1223 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
92e8c1ff 1224 if "$@" >${OUTPUT} 2>&1; then
0440d936
DK
1225 msgpass
1226 else
0d58c26a
DK
1227 echo >&2
1228 cat >&2 $OUTPUT
0440d936
DK
1229 msgfail
1230 fi
1231}
1232
1233testfailure() {
1234 if [ "$1" = '--nomsg' ]; then
1235 shift
1236 else
889b0072 1237 msgtest 'Test for failure in execution of' "$*"
0440d936 1238 fi
03938280 1239 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
0440d936 1240 if $@ >${OUTPUT} 2>&1; then
0d58c26a
DK
1241 echo >&2
1242 cat >&2 $OUTPUT
0440d936
DK
1243 msgfail
1244 else
1245 msgpass
1246 fi
1247}
1248
0d58c26a
DK
1249testwebserverlaststatuscode() {
1250 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
1251 local STATUS='rootdir/tmp/webserverstatus-statusfile.log'
1252 rm -f "$DOWNLOG" "$STATUS"
1253 msgtest 'Test last status code from the webserver was' "$1"
1254 downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG"
1255 if [ "$(cat "$STATUS")" = "$1" ]; then
1256 msgpass
1257 else
1258 echo >&2
1259 if [ -n "$2" ]; then
1260 shift
1261 echo >&2 '#### Additionally provided output files contain:'
1262 cat >&2 "$@"
1263 fi
1264 echo >&2 '#### Download log of the status code:'
1265 cat >&2 "$DOWNLOG"
1266 msgfail "Status was $(cat "$STATUS")"
1267 fi
1268}
1269
89a1aa5d
DK
1270pause() {
1271 echo "STOPPED execution. Press enter to continue"
1272 local IGNORE
1273 read IGNORE
1274}